import { type IFunctionType } from './types';
import { type FirebaseFunction } from './IFirebaseFunction';
import { type FirebaseRequest } from './IFirebaseRequest';
import { type FirebaseSchedule } from './IFirebaseSchedule';
import { type IDatabaseScheme } from './database';
export type FirebaseDescriptor = FirebaseDescriptor.Function<IFunctionType.Erased, unknown> | FirebaseDescriptor.Request<IFunctionType.Erased> | FirebaseDescriptor.Schedule;
export declare namespace FirebaseDescriptor {
    type Function<FunctionType extends IFunctionType.Erased, ResponseContext> = [FirebaseFunction.Constructor<FunctionType, ResponseContext, IDatabaseScheme>];
    type Request<FunctionType extends IFunctionType.Erased> = [FirebaseRequest.Constructor<FunctionType, IDatabaseScheme>, void];
    type Schedule = [FirebaseSchedule.Constructor<IDatabaseScheme>, string, void];
    function _function<FunctionType extends IFunctionType.Erased, ResponseContext = never>(firebaseFunction: FirebaseFunction.Constructor<FunctionType, ResponseContext, IDatabaseScheme>): FirebaseDescriptor;
    function request<FunctionType extends IFunctionType.Erased>(firebaseRequest: FirebaseRequest.Constructor<FunctionType, IDatabaseScheme>): FirebaseDescriptor;
    function schedule(schedule: string, firebaseSchedule: FirebaseSchedule.Constructor<IDatabaseScheme>): FirebaseDescriptor;
}
