import * as functions from 'firebase-functions';
import { type PrivateKeys, type DatabaseType } from './types';
import { type IDatabaseScheme, type IDatabaseReference } from './database';
export interface IFirebaseSchedule {
    execute(): Promise<void>;
}
export declare namespace FirebaseSchedule {
    type Constructor<DatabaseScheme extends IDatabaseScheme> = new (databaseType: DatabaseType, databaseReference: IDatabaseReference<DatabaseScheme>) => IFirebaseSchedule;
    function create<DatabaseScheme extends IDatabaseScheme>(FirebaseSchedule: FirebaseSchedule.Constructor<DatabaseScheme>, getPrivateKeys: (databaseType: DatabaseType) => PrivateKeys, schedule: string, databaseType: DatabaseType): functions.CloudFunction<unknown>;
}
